<template>
    <Filter @filterChanged="handleFilterChanged"/>
    <div class="map">
        <div class="map__element" id="map"></div>
        <div class="map__vehicle-tooltip" ref="vehiclePopup">
            <VehiclePopup :focusedVehicle="focusedVehicle" />
        </div>
    </div>

</template>
  
  <script>
  import L from "leaflet/dist/leaflet";
  import "leaflet/dist/leaflet.css";
  import config from "@/config"
  import VehiclePopup from "./VehiclePopup.vue";
  
  export default {
    name: "Map",
    
    data() {
        return {
            focusedVehicle: null,
            vehicleMarkers: [],
            filteredMarkers: [],
            clickedVehicle: null
        }
    },
    setup() {
        const mapStore = useMapStore()
        const filterStore = useFilterState()
        return { mapStore, filterStore };
    },

    mounted() {
        this.initMap()
        this.initVehicles()
        console.log(this);
        // this.$root.$on('filterChanged', (payload) => {
        //     console.log('filterChanged')
        // });
    },
    methods: {
        handleFilterChanged(){
            this.applyFilters();
        },
        fetchVehicles() {
            this.removeVehicles();
            this.mapStore.fetchVehicles(()=>{
                this.drawVehicles();
            });
            setTimeout(this.fetchVehicles, 60000);
        },
        applyFilters() {
            this.redrawVehicles();
        },
        redrawVehicles() {
            this.removeVehicles();
            this.drawVehicles();
        },
        initMap() {

            this.map = L.map('map').setView([config.map.center.lat, config.map.center.lng], config.map.zoom);

            // Controls
            new L.Control.Zoom({position: "bottomright",}).addTo(this.map);
            new L.Control.Scale({maxWidth: 150,imperial: false,}).addTo(this.map);
    
            this.map.on("click", this.onClick);
            this.map.on("dblclick", this.onDblclick);

            // Add a tile layer to the map
            L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
            }).addTo(this.map);

            this.vehiclePopup = L.popup({});

            
        },
        initVehicles() {

            this.vehicleMarkers = [];

            this.fetchVehicles()
            this.drawVehicles()

            this.map.on("zoomend", () => {this.redrawVehicles()})
            this.map.on("moveend", () => {this.redrawVehicles()})

        },
        vehiclePopup(vehicle){
            console.log(vehicle);
        },
        unfocusVehicle(){
            console.log("v", this.focusedVehicle)
            this.focusedVehicle = null;
        },
        drawVehicles() {
            this.mapStore.vehicles.forEach((vehicle)=>{

                if (!this.filterStore.validate(vehicle)){
                    return;
                }

                // If marker is not visible on current map view, continue
                if (!this.map.getBounds().pad(0.1).contains([vehicle.latitude, vehicle.longitude])) {
                    return;
                }

                let rotation = 45 + vehicle.azimuth;
                
                const marker = L.marker([vehicle.latitude,vehicle.longitude], {
                    icon: L.divIcon({
                        iconAnchor: [0,0],
                        html: `
                            <div class="vehicle-icon vehicle-icon__type-${vehicle.transportType}" style='transform: rotate(${rotation}deg)'>

                            </div>
                            <div class="vehicle-icon-line">${vehicle.line}</div>
                            
                        `,
                    })
                }).bindTooltip(this.$refs.vehiclePopup, {
                    direction: "top",
                    opacity: 1
                })
                .addTo(this.map)

                marker.on("click", (e) => {
                    this.clickedVehicle = vehicle
                })

                marker.on("mouseover", (e) => {
                    this.focusedVehicle = toRaw(vehicle);

                    this.$nextTick(() => {
                        // Adjust width after DOM is loaded
                        marker.getTooltip().update();
                    });
                });

                // marker.on("mouseout", (e) => {
                //     console.log("unfocusing")
                //     this.unfocusVehicle();
                // });

                this.vehicleMarkers.push([vehicle.number, marker]);

            })
        }, 
        removeVehicles() {
            if (this.vehicleMarkers) {
                this.vehicleMarkers.forEach(([vehicleId, marker]) => {
                    marker.remove();
                });
            }
            this.vehicleMarkers = [];
        },
        updateMarkers(vehicles) {

        }
    }
}
</script>

<style lang="scss">
.map {
    width: 100%;
    height: 100%;
    overscroll-behavior: contain;
    position: relative;
    &__element {
        height: 100%;
        z-index: 0;
    }
}

.leaflet-marker-icon {
  border: none;
}

.leaflet-div-icon {
  background: none;
  width: 0 !important;
  height: 0 !important;
}


.leaflet-marker-icon {
    position: absolute;
    width: 28px !important;
    height: 28px !important;
    border-radius: 50%;
    border-top-left-radius: 2px;
}


.vehicle-icon {
    border-radius: 2px 50% 50%;
    height: 28px;
    position: absolute;
    width: 28px;
    &-line {
        color: #fff;
        font-size: 15px;
        font-weight: 800;
        position: absolute;
        align-items: center;
        display: flex;
        justify-content: center;
        width: 100%;
        height: 100%;
    }
    &__type-bus {
        background: $bg-blue;
    }
    &__type-tram {
        background: $bg-red;
    }
    &__type-trolley {
        background: $bg-orange;
    }

    &__marker {
        position: absolute;
        width: 28px;
        height: 28px;
        border-radius: 50%;
        border-top-left-radius: 2px;
    }

}

</style>